{-# LANGUAGE UndecidableSuperClasses #-}
{-# OPTIONS_GHC -Wno-redundant-constraints #-}

-- | Entrypoints utilities for Lorentz
module Lorentz.EntryPoints
  ( -- * Typeclasses
    EntryPointsDerivation (..)
  , ParameterHasEntryPoints (..)
  , ParameterDeclaresEntryPoints

    -- * Entrypoints API
  , AllParameterEntryPoints
  , LookupParameterEntryPoint
  , parameterEntryPointsToNotes
  , flattenEntryPoints
  , GetEntryPointArg
  , parameterEntryPointCall
  , GetDefaultEntryPointArg
  , parameterEntryPointCallDefault
  , NoExplicitDefaultEntryPoint
  , EntryPointRef (..)
  , eprName
  , GetEntryPointArgCustom
  , HasEntryPointArg (..)
  , HasDefEntryPointArg
  , TrustEpName (..)
  , parameterEntryPointCallCustom

    -- * Implementations
  , ParameterWrapper (..)
  , EpdNone
  , EpdPlain
  , EpdRecursive
  ) where

import Lorentz.EntryPoints.Core
import Lorentz.EntryPoints.Impl
import Lorentz.EntryPoints.Manual
